/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef asyncfifo_h
#define asyncfifo_h

#ifdef ASYNCFIFO_USE_GLIB

#include <glib.h>

typedef GAsyncQueue AsyncFifo;

#define async_fifo_new() g_async_queue_new()
#define async_fifo_free(a) g_async_queue_unref(a)
#define async_fifo_push(a,b) g_async_queue_push(a,b)
#define async_fifo_pop(a) g_async_queue_pop(a)

#else

typedef struct _AsyncFifo AsyncFifo;
typedef void(*AsyncFifoCallback)(void*,void*);

AsyncFifo* async_fifo_new(void);
void async_fifo_free(AsyncFifo*);

void async_fifo_push(AsyncFifo*,void*);
void* async_fifo_pop(AsyncFifo*);
void* async_fifo_try_pop(AsyncFifo*);

int async_fifo_fd(AsyncFifo*);
void async_fifo_wait(AsyncFifo*);

#endif

#endif /* asyncfifo_h */
