/*
 * Copyright (C) 2018-2019  Magnus Bergman <magnus@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
#include "keyboard.h"
#include "signals.h"

static Signal keyboard_signal;

SignalSubscription* keyboard_subscribe(KeyboardHandler handler,void* userdata){
    return signal_subscribe(&keyboard_signal,(SignalHandler)handler,userdata);
}


void keyboard_unsubscribe(SignalSubscription* ss){
    signal_unsubscribe(&keyboard_signal,ss);
}


typedef struct{
    int key;
}Key;
static int keyboard_key_marshal(KeyboardHandler handler,void* userdata,Key* k){
    return handler(userdata,k->key);
}
int keyboard_key(int key){
    Key k;
    k.key = key;
    return signal_invoke_marshal(&keyboard_signal,(SignalMarshall)keyboard_key_marshal,&k);
}
