/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef keyboard_h
#define keyboard_h

#include "signals.h"

#define KEYBOARD_UP       -1
#define KEYBOARD_DOWN     -2
#define KEYBOARD_LEFT     -3
#define KEYBOARD_RIGHT    -4
#define KEYBOARD_HOME     -5
#define KEYBOARD_END      -6
#define KEYBOARD_PAGEUP   -7
#define KEYBOARD_PAGEDOWN -8

typedef int(KeyboardHandler)(void* userdata,int key);

SignalSubscription* keyboard_subscribe(KeyboardHandler,void*);
void keyboard_unsubscribe(SignalSubscription*);
int keyboard_key(int key);

#endif /* keyboard_h */
