/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef worker_h
#define worker_h

#include "dispatch.h"

typedef struct _Worker Worker;

typedef struct{
    void(*done)(Worker*);
    void(*dispatch)(Worker*,DispatchFunc,void*);
    int(*try_dispatch)(Worker*,DispatchFunc,void*);
    void(*wait)(Worker*);
}WorkerInterface;

struct _Worker{
    const WorkerInterface* vt;
};

#define worker_done(a) (a)->vt->done(a)
void worker_free(Worker*);
#define worker_dispatch(a,b,c) (a)->vt->dispatch(a,b,c)
#define worker_try_dispatch(a,b,c) (a)->vt->try_dispatch(a,b,c)
#define worker_wait(a) (a)->vt->wait(a)

#endif /* worker_h */
